package se.jernlas.swing.gem.types;

import javax.swing.JComponent;

/**
 * A type of text that can be identified from a string and generate a 
 * Tip in the shape of a swing component.
 *  
 * @author jernlas
 */
public abstract class TextType {

   /**
    * Identifies a formal letter
    */
   public static final TextType FORMAL_LETTER = FormalLetterType.getInstance();
   
   /**
    * Identifies an informal letter
    */
   public static final TextType INFORMAL_LETTER = InformalLetterType.getInstance();

   /**
    * Generates a swing component that represents this tip.
    * @return The component.
    */
   public abstract JComponent getTip();

   /**
    * Check if the string matches this document type.
    * @param text The text to check
    * @return true if the text matches this type of document.
    */
   public abstract boolean isThisType(String text);

}
